
<p>Dekoderi određenog koda su kombinacijski sklopovi koji obavljaju dekodiranje kodnih riječi tog koda: oni na ulaz dobiju kodnu riječ, imaju onoliko izlaza koliko u domeni koda ima simbola i na temelju kodne riječi narinute na ulaze generiraju jedinicu na izlazu koji odgovara simbolu čija je to kodna riječ; svi ostali izlazi postavljaju se u 0. Primjetite sada da je izlaz dekodera kodna riječ jednojediničnog koda. U funkcionalnom smislu, dekoderi obavljaju inverznu operaciju od one koju rade koderi za određeni kod.</p>

<p>Dekoder ima onoliko ulaza koliko bitova ima kodna riječ te onoliko izlaza koliko ima simbola u domeni koda.</p>

<h3><i>n</i>-bitni binarni dekoder</h3>

<p><i>n</i>-bitni binarni dekoder je dekoder za <i>n</i>-bitni prirodni binarni kod. Prisjetimo se ponovno tog koda: 3-bitni prirodni binarni kod cijelim brojevima 0 do 7 pridjeljuje trobitne kodne riječi, kako je prikazano na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(nbc-kod-3-hr.svg)" alt="Trobitni prirodni binarni kod"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Trobitni prirodni binarni kod.</figcaption>
</figure>

<p>3-bitni binarni dekoder dobiva trobitnu binarnu kodnu riječ A<sub>2</sub>A<sub>1</sub>A<sub>0</sub> te na izlaze I<sub>7</sub>I<sub>6</sub>I<sub>5</sub>I<sub>4</sub>I<sub>3</sub>I<sub>2</sub>I<sub>1</sub>I<sub>0</sub> postavlja jedinicu na mjesto broja čiji je trobitni kod doveden na ulaz. Primjerice, ako se na ulaz dovede 101, očekujemo izlaz 00100000 (odnosno jedinicu na izlazu I<sub>5</sub>).</p>

<p>Interaktivna simulacija u nastavku ilustrira rad 3-bitnog binarnog dekodera. Mišem možete mijenjati vrijednosti koje se dovode na ulaze.</p>

<script>
@#page-include#(decoder-util.js)
@#page-include#(decoder.js)
@#page-include#(decimal-decoder.js)
</script>

<div style="text-align: center;">
  <canvas id="decoderCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
setupDecoder("decoderCanvas", [0, 0, 0], false).decoder.drawAll();
</script>

<p>Dekoder može imati i dodatni (upravljački) ulaz za <em>omogućavanje</em> (engl. <i>enable-input</i>). Kad je na tom ulazu logička vrijednost 1, dekoder radi na prethodno opisani način. Kad je na tom ulazu logička vrijednost 0, kažemo da je dekoder <em>onemogućen</em> i svi su njegovi izlazi postavljeni na vrijednost 0, neovisno o kodnoj riječi koja je dovedena na njegove ulaze. Primjer ovakvog binarnog dekodera prikazan je u nastavku. Ulaz za omogućavanje prikazan je na vrhu dekodera i mišem možete mijenjati vrijednost koja se na njega dovodi. Isprobajte!</p>

<div style="text-align: center;">
  <canvas id="decoderECanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
setupDecoder("decoderECanvas", [0, 0, 0], true).decoder.drawAll();
</script>


<h3>BCD-dekoder</h3>

<p>BCD-dekoder je dekoder za BCD-kod (koji je pak kod za prikaz dekadskih znamenaka); specifikacija koda prikazana je na slici 2. Dekoder ima četiri ulaza na koja se postavlja četiri-bitna kodna riječ. Ulazi su označeni s A<sub>3</sub>A<sub>2</sub>A<sub>1</sub>A<sub>0</sub> pri čemu je ulaz A<sub>3</sub> namijenjen za dovođenje bita najveće težine. Dekoder ima deset izlaza koji su označeni s 0 do 9. Izlaz <i>i</i> predstavlja simbol odnosno znamenku <i>i</i>.</p>

<figure class="mlFigure">
<img src="@#file#(bcd-kod-hr.svg)" alt="BCD-kod"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> BCD-kod.</figcaption>
</figure>

<p>Kako se radi o kodu za prikaz dekadskih znamenaka kojih ima samo 10, za binarne kombinacije koje nisu kod niti jedne od dekadskih znamenaka, izlazi dekodera nisu specificirani. Interaktivna implementacija dekodera dana u nastavku će u svim takvim situacijama sve izlaze postaviti u 0. Isprobajte rad ovog dekodera; klikom miša možete mijenjati binarne kombinacije koje se dovode na ulaze.</p>

<div style="text-align: center;">
  <canvas id="bcdDecoderCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
setupBCDDecoder("bcdDecoderCanvas").decoder.drawAll();
</script>

<h3>Excess-3-dekoder</h3>

<p>Excess-3-dekoder je dekoder za kod Excess-3. I ovo je kod za prikaz dekadskih znamenaka čija je specifikacija prikazana na slici 3. Kod je samokomplementirajući. Broj ulaza i izlaza kao i oznake jednake su kao i kod dekodera za kod BCD.</p>

<figure class="mlFigure">
<img src="@#file#(ex3-kod-hr.svg)" alt="Excess-3-kod"><br>
<figcaption><span class="mlFigKey">Slika 3.</span> Excess-3-kod.</figcaption>
</figure>

<p>Kako se radi o kodu za prikaz dekadskih znamenaka kojih ima samo 10, za binarne kombinacije koje nisu kod niti jedne od dekadskih znamenaka, izlazi dekodera nisu specificirani. Interaktivna implementacija dekodera dana u nastavku će u svim takvim situacijama sve izlaze postaviti u 0. Isprobajte rad ovog dekodera; klikom miša možete mijenjati binarne kombinacije koje se dovode na ulaze.</p>

<div style="text-align: center;">
  <canvas id="ex3DecoderCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
setupEx3Decoder("ex3DecoderCanvas").decoder.drawAll();
</script>

<h3>Aikenov dekoder</h3>

<p>Aikenov dekoder je dekoder za Aikenov kod (poznat još i kao 2421-kod). To je kod za prikaz dekadskih znamenaka čija je specifikacija prikazana na slici 4. Kod je samokomplementirajući. Broj ulaza i izlaza kao i oznake jednake su kao i kod dekodera za kod BCD.</p>

<figure class="mlFigure">
<img src="@#file#(aiken-kod-hr.svg)" alt="Aikenov kod"><br>
<figcaption><span class="mlFigKey">Slika 4.</span> Aikenov kod.</figcaption>
</figure>

<p>Kako se radi o kodu za prikaz dekadskih znamenaka kojih ima samo 10, za binarne kombinacije koje nisu kod niti jedne od dekadskih znamenaka, izlazi dekodera nisu specificirani. Interaktivna implementacija dekodera dana u nastavku će u svim takvim situacijama sve izlaze postaviti u 0. Isprobajte rad ovog dekodera; klikom miša možete mijenjati binarne kombinacije koje se dovode na ulaze.</p>

<div style="text-align: center;">
  <canvas id="aikenDecoderCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Kristijan Vulinović</span>
</div>

<script>
setupAikenDecoder("aikenDecoderCanvas").decoder.drawAll();
</script>

